function [s] = my_l1_solver(D,b,tol,lmd,mtd,nng)
switch lower(mtd)
%           case {'l1_ls'}
%             [s, ntiter ,status] = SolveL1LS(D,b,'tolerance',tol,'lambda',lmd,'isnonnegative',nng);
          case 'fista'
            [s,nIter] = SolveFISTA_NNG(D,b,'tolerance',tol,'lambda',lmd,'isnonnegative',nng);
%           case 'homotopy'
%             lmd = 2*max(abs(D'*b));
%             [s, total_iter] = SolveHomotopy(D,b,'tolerance',tol,'lambda',lmd,'isnonnegative',nng);
%             if nng && ~isempty(find(s<0))
%                error('Not nonnegative~');
%             end
%           case 'omp'
%             [s, k] =
%             SolveOMP(D,b,'tolerance',tol,'lambda',lmd,'isnonnegative',nng);
          case 'o_l1ls'
             [s,status,history] = l1_ls_nonneg(D,b,tol,lmd,true);
          case 'nncs'
             [s] = my_nncs(D,b,lmd);
             % should make sure s is accurate
%           case 'yall1'
%              opts.tol = tol;
%              opts.nu  = 0;
%              opts.rho = 2/lmd;
%              opts.basis = eye(size(D,2));
%              opts.nonneg = 1;
%              opts.weights = [1];
%              [s, Out] = yall1(D, b, opts)
          otherwise
            disp('Unknown method.')
end