function [s] = my_nncs(D,b,lambda)
lmd = 0.5*lambda;
s=abs(rand(size(D,2),1));
s=s./(sqrt(sum(s.^2,2))*ones(1,1));

z   = b-D*s;
DTb = D'*b;
DTD = D'*D;
while 1
   s_pref = s;
   s = s_pref.*DTb./(DTD*s_pref+lmd);
   if norm(s-s_pref,2)/norm(s,2)<5e-5
      break 
   end
end